> ## Documentation Index
> Fetch the complete documentation index at: https://goldrush.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Arc Onchain Data API

> Get token balances and transactions for Arc. 22 endpoints supported.

## Overview

> [!TIP]
>
> Arc is an open L1 blockchain purpose-built to unite programmable money and onchain innovation with real-world economic activity.

GoldRush offers the most comprehensive Arc Data API suite for developers, analysts, and enterprises. Whether you're
building a DeFi dashboard, a wallet, a trading bot, an AI agent or a compliance platform,
our Arc Data APIs provide fast, accurate, and developer-friendly access to the essential onchain data you need.

### Supported APIs

> [card] [Foundational API](https://goldrush.dev/docs/goldrush-foundational-api)
>
> Access structured historical blockchain data across 100+ chains using REST APIs.
> Get token balances, transaction histories, decoded event logs, NFT assets, token holders and more.\
> \\
>
> **Use cases: Wallets, portfolio trackers, crypto accounting & tax tools, and DeFi dashboards.**

## Mainnet

| Property | Value |
| - | - |
| **Chain Name** | `arc-mainnet` |
| **Chain ID** | `5042` |
| **Network Type** | Frontier Chain |
| **Support Level** | frontier |
| **Block Explorer** | [Arc Explorer](https://explorer.arc.io/) |
| **Official Website** | [Arc Website](https://www.arc.network/) |
| **Native Gas Token** | USDC |

## API Usage

To use this blockchain network in GoldRush API calls, use:

#### Chain Name

* `arc-mainnet` (mainnet)

#### Example API Calls

```bash Chain Name (Mainnet) theme={null}
curl -X GET "https://api.covalenthq.com/v1/arc-mainnet/address/0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045/balances_v2/?key=<GOLDRUSH_API_KEY>"
```

#### SDK Usage

```typescript TypeScript SDK (Mainnet) theme={null}
import { GoldRushClient } from "@covalenthq/client-sdk";

const client = new GoldRushClient("<GOLDRUSH_API_KEY>");
const resp = await client.BalanceService.getTokenBalancesForWalletAddress({
    chainName: "arc-mainnet",
    walletAddress: "0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045"
});
```

## Foundational API Support

This chain supports **22**  GoldRush Foundational APIs:

#### Wallet API

* **[ERC-20 Token Balance API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/balances/get-token-balances-for-address.md)**
* **[Native Token Balance API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/balances/get-native-token-balance.md)**
* **[Historical Portfolio Value API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/balances/get-historical-portfolio-value-over-time.md)**
* **[ERC-20 Token Transfers API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/balances/get-erc20-token-transfers-for-address.md)**

#### Pricing API

* **[Historical Token Price API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-historical-token-prices.md)**

#### Security API

* **[Token Approvals API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/security/get-token-approvals-for-address.md)**

#### Transactions API

* **[Transaction API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-a-transaction.md)** `with-input-data` `with-internal` `with-classification`
* **[Wallet Transaction Summary API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-transaction-summary-for-address.md)**
* **[Earliest Wallet Transactions API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-earliest-transactions-for-address-v3.md)** `with-input-data` `with-internal` `with-classification`
* **[Wallet Transaction History API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-recent-transactions-for-address-v3.md)** `with-input-data` `with-internal` `with-classification`
* **[Paginated Wallet Transactions API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-paginated-transactions-for-address-v3.md)** `with-input-data` `with-internal` `with-classification`
* **[Time Bucket Transactions API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-time-bucket-transactions-for-address-v3.md)**
* **[Block Transactions API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-all-transactions-in-a-block.md)**
* **[Block Transactions API by Page on Arc](https://goldrush.dev/docs/api-reference/foundational-api/transactions/get-all-transactions-in-a-block-by-page.md)**

#### Block Explorer API

* **[Block API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-a-block.md)**
* **[Block Heights API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-block-heights.md)**
* **[Chain Status API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-all-chain-statuses.md)**
* **[Contract Event Logs API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-log-events-by-contract-address.md)**
* **[Event Logs API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-logs.md)**
* **[Event Logs by Topic Hash API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-log-events-by-topic-hash.md)**
* **[Gas Price API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-gas-prices.md)**
* **[Supported Chains API on Arc](https://goldrush.dev/docs/api-reference/foundational-api/utility/get-all-chains.md)**

## Internal Transactions (`with-internal`)

Arc supports **internal transactions** (traces). The Transactions API endpoints marked `with-input-data` `with-internal` above accept the `with-internal=true` query parameter, which includes internal transactions (the value transfers triggered by contract execution that are not recorded as standalone onchain transactions) in the response.

> [!NOTE]
>
> Internal transactions are included in the response by passing `with-internal` and cost `0.05` credits/item.

#### Example API Call

```bash Recent transactions with internal transactions theme={null}
curl -X GET "https://api.covalenthq.com/v1/arc-mainnet/address/0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045/transactions_v3/?with-internal=true&key=<GOLDRUSH_API_KEY>"
```

## Transaction Classification (`with-classification`)

Arc supports **transaction classification**. Pass `with-classification=true` to the Transactions API to get a type (such as `swap` or `send_token`), a category, a plain-English description, and the assets sent and received for each transaction.

> [!NOTE]
>
> Transaction classification costs `0.05` credits/item.

#### Example API Call

```bash Recent transactions with classification theme={null}
curl -X GET "https://api.covalenthq.com/v1/arc-mainnet/address/0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045/transactions_v3/?with-classification=true&key=<GOLDRUSH_API_KEY>"
```

## Additional Resources

* [GoldRush API Documentation](https://goldrush.dev/docs/)
* [Supported Chains List](https://goldrush.dev/chains/)
* [API Reference](https://goldrush.dev/docs/api-reference/)


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.